"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = void 0;
var _Actions = _interopRequireDefault(require("farce/Actions"));
var _createHistoryEnhancer = _interopRequireDefault(require("farce/createHistoryEnhancer"));
var _queryMiddleware = _interopRequireDefault(require("farce/queryMiddleware"));
var _redux = require("redux");
var _Matcher = _interopRequireDefault(require("./Matcher"));
var _createMatchEnhancer = _interopRequireDefault(require("./createMatchEnhancer"));
var _foundReducer = _interopRequireDefault(require("./foundReducer"));
function createFarceStore({
  historyProtocol,
  historyMiddlewares,
  historyOptions,
  routeConfig,
  matcherOptions
}) {
  const store = (0, _redux.createStore)((0, _redux.combineReducers)({
    found: _foundReducer.default
  }), (0, _redux.compose)((0, _createHistoryEnhancer.default)(Object.assign({}, historyOptions, {
    protocol: historyProtocol,
    middlewares: historyMiddlewares || [_queryMiddleware.default]
  })), (0, _createMatchEnhancer.default)(new _Matcher.default(routeConfig, matcherOptions))));
  store.dispatch(_Actions.default.init());
  return store;
}
var _default = createFarceStore;
exports.default = _default;
module.exports = exports.default;