"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = createRender;
var _react = _interopRequireDefault(require("react"));
var _ElementsRenderer = _interopRequireDefault(require("./ElementsRenderer"));
var _StaticContainer = _interopRequireDefault(require("./StaticContainer"));
var _jsxRuntime = require("react/jsx-runtime");
/**
 * A convenience method for handling the 3 main states a route match might produce.
 */
function createRender({
  renderPending,
  renderReady,
  renderError
}) {
  return function render(renderArgs) {
    // TODO: error and elements MIGHT exist, depending on type of renderArgs
    const {
      error,
      elements
    } = renderArgs;
    let element;
    if (error) {
      element = renderError ? renderError(renderArgs) : null;
    } else if (!elements) {
      element = renderPending ? renderPending(renderArgs) : undefined;
    } else if (renderReady) {
      element = renderReady(renderArgs);
    } else {
      element = /*#__PURE__*/(0, _jsxRuntime.jsx)(_ElementsRenderer.default, {
        elements: elements
      });
    }
    const hasElement = element !== undefined;
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(_StaticContainer.default, {
      shouldUpdate: hasElement,
      children: hasElement ? element : null
    });
  };
}
module.exports = exports.default;