"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.default = createStoreRouterObject;
var _Actions = _interopRequireDefault(require("farce/Actions"));
var _redux = require("redux");
const NAVIGATION_ACTION_CREATORS = {
  push: _Actions.default.push,
  replace: _Actions.default.replace,
  go: _Actions.default.go
};
function createStoreRouterObject(store) {
  // TODO: create an enhanced store type with found and farce maybe?
  const {
    farce,
    found
  } = store;
  const {
    matcher
  } = found;
  return Object.assign({}, (0, _redux.bindActionCreators)(NAVIGATION_ACTION_CREATORS, store.dispatch), farce, found, {
    // Expose isActive from matcher directly for convenience. This pattern is
    // faster than using matcher.isActive.bind(matcher).
    isActive: (match, location, options) => matcher.isActive(match, location, options)
  });
}
module.exports = exports.default;